

import {Component} from '@angular/core';
import {IonicPage, NavController, NavParams, AlertController, ToastController, ModalController, App} from 'ionic-angular';
import {AuthService} from "../../providers/auth-service";
import {CalendarModal, CalendarModalOptions, CalendarResult} from "ion2-calendar";
import {OfficePage} from '../office/office';
/**
 * Created By : ZULQANI FAUZI
 * Created Date : 23/07/2018
 * Updated Date : 24/07/2018
 */
@IonicPage()
@Component({
    selector: 'page-btb',
    templateUrl: 'btb.html',
})
export class BtbPage {
    shownGroup = null;
    resposeData: any;
    recartDataBTB: any;
    dataProduct: any;
    noRecords: boolean = false;
    userDetails: any;
    cartDataBTB: any;
    results: any;
    total_item: number;
    userPostData = {
        nama_depan: "",
        nama_belakang: "",
        id_member: ""
    };
    tiba: Date;
    userCartBTB = {
        pengajuan: "",
        tiba: "",
        cart_id: "",
        id_pelanggan: "",
        nama_pelanggan: "",
        username: "",
        ItemID: "",
        trans_id : "",
        production_date : "",
        quantity: 0,
        price: "",
        token: "",
        cart_item_id: "",
        catatan: "",
        diskon: "",
        jumlah_diskon: 0,
        promo: "",
        id_promo: "",
        pajak: true,
        ppn: 0,
        type_cart: "",
    }
    items: any[] = [];
    itemsDetail: any[] = [];

    toggleGroup(group) {
        if (this.isGroupShown(group)) {
            this.shownGroup = null;
        } else {
            this.shownGroup = group;
        }
    };
    isGroupShown(group) {
        return this.shownGroup === group;
    };
    constructor(public navCtrl: NavController, public navParams: NavParams,
        public modalCtrl: ModalController,
        public authService: AuthService,
        public app: App,
        public alertCtrl: AlertController,
        private toastCtrl: ToastController) {
        const data = JSON.parse(localStorage.getItem("userData"));
        this.userDetails = data.userData;
        this.userCartBTB.username = this.userDetails.username;
        var d = new Date(), month = '' + (d.getMonth() + 1), day = '' + d.getDate(), year = d.getFullYear();
        var n = month + "/" + day + "/" + year;
        var newdate = new Date(n);
        newdate.setDate(newdate.getDate() + 20);
        var dd = newdate.getDate();
        var mm = newdate.getMonth() + 1;
        var yy = newdate.getFullYear();
        this.userCartBTB.pengajuan = year + "-" + month + "-" + day;
        this.userCartBTB.tiba = yy + "-" + mm + "-" + dd;
        this.userCartBTB.type_cart = "2";
        this.getRO();
        this.getRODetail();
        this.getCart();
    }
    getRO() {
        this.authService.postData(this.userPostData, "getRO").then(
            result => {
                this.resposeData = result;
                if (this.resposeData.DataRO) {
                    this.dataProduct = this.resposeData.DataRO;
                    for (let i = 0; i < this.resposeData.DataRO.length; i++) {
                        let a = this.resposeData.DataRO[i].TransID;
                        let b = this.resposeData.DataRO[i].OutletID;
                        let c = this.resposeData.DataRO[i].TransDate;
                        let d = this.resposeData.DataRO[i].EstimationDate;
                        let e = this.resposeData.DataRO[i].Remark;
                        this.items.push({
                            "TransID": a,
                            "OutletID": b,
                            "TransDate": c,
                            "EstimationDate": d,
                            "Remark": e
                        });
                    }
                } else {
                    this.presentToast("Gagal terhubung ke server.");
                }
            },
            err => {
                this.presentToast("Gagal terhubung ke server.");
            }
        );
    }
    getRODetail() {
        this.authService.postData(this.userPostData, "getRODetail").then(
            result => {
                this.resposeData = result;
                if (this.resposeData.DataRODetail) {
                    this.dataProduct = this.resposeData.DataRODetail;
                    for (let i = 0; i < this.resposeData.DataRODetail.length; i++) {
                        let TransID = this.resposeData.DataRODetail[i].TransID;
                        let a = this.resposeData.DataRODetail[i].ROID;
                        let b = this.resposeData.DataRODetail[i].WHSIDTo;
                        let c = this.resposeData.DataRODetail[i].TransDate;
                        let e = this.resposeData.DataRODetail[i].TransferRemark;
                        let f = this.resposeData.DataRODetail[i].ItemID;
                        let g = this.resposeData.DataRODetail[i].ItemName;
                        let h = this.resposeData.DataRODetail[i].Qnty;
                        let j = this.resposeData.DataRODetail[i].UOMName;
                        let k = this.resposeData.DataRODetail[i].ProductionDate;
                        
                        this.itemsDetail.push({
                            "TransID": TransID,
                            "ROID": a,
                            "OutletID": b,
                            "TransDate": new Date(c).toISOString(),
                            "EstimationDate": c,
                            "Remark": e,
                            "ItemID": f,
                            "ItemName": g,
                            "Qnty": h,
                            "UOMName": j,
                            "ProductionDate":k
                        });
                        
                    }
                } else {
                    this.presentToast("Gagal terhubung ke server.");
                }
            },
            err => {
                this.presentToast("Gagal terhubung ke server.");
            }
        );
    }
    
    insertCartBTB($data) {
        this.userCartBTB.price = '0';
        this.userCartBTB.quantity = $data.Qnty;
        this.userCartBTB.type_cart = "3";
        this.userCartBTB.trans_id = $data.TransID;
        this.userCartBTB.ItemID = $data.ItemID;
        this.userCartBTB.id_pelanggan = '1';
        this.userCartBTB.production_date = $data.ProductionDate;
        if (this.userCartBTB.ItemID) {
            this.authService.postData(this.userCartBTB, "insertCartBTB").then(
                result => {
                    this.resposeData = result;
                    if (this.resposeData.cartData) {
                        this.cartDataBTB = this.resposeData.cartData;
                        this.total_item = this.cartDataBTB.length;
                        setTimeout(() => {
                        }, 150);
                    }
                },
                err => {
                    this.presentToast("Gagal terhubung ke server.");
                }
            );
        } else {
            this.presentToast("Gagal mengambil produk.");
        }
       
    }

    getCart() {
        this.userCartBTB.type_cart = "3";
        this.authService.postData(this.userCartBTB, "getCart").then(
            result => {
                this.recartDataBTB = result;
                if (this.recartDataBTB.cartData) {
                    this.cartDataBTB = this.recartDataBTB.cartData;
                    this.userCartBTB.cart_id = this.cartDataBTB[0].cart_id;
                    this.userCartBTB.id_pelanggan = this.cartDataBTB[0].id_pelanggan;
                    this.userCartBTB.nama_pelanggan = this.cartDataBTB[0].nama_depan + " " + this.cartDataBTB[0].nama_belakang;
                    this.userCartBTB.promo = this.cartDataBTB[0].promo;
                    this.total_item = this.cartDataBTB.length;
                }
            },
            err => {
                this.presentToast("Gagal terhubung ke server.");
            }
        );
    }

    updateCart($value) {
        this.userCartBTB.cart_item_id = $value.cart_item_id;
        this.userCartBTB.quantity = $value.quantity;
        this.userCartBTB.price = $value.price;
        this.userCartBTB.ItemID = $value.product_id;
        this.authService.postData(this.userCartBTB, "updateCart").then(
            result => {
                this.recartDataBTB = result;
                if (this.recartDataBTB.cartData) {
                    this.cartDataBTB = this.recartDataBTB.cartData;
                    this.total_item = this.cartDataBTB.length;
                }
            },
            err => {
                this.presentToast("Gagal terhubung ke server.");
            }
        );
    }

    deleteCart($value) {
        this.userCartBTB.cart_item_id = $value.cart_item_id;
        this.userCartBTB.quantity = $value.quantity;
        this.userCartBTB.price = $value.price;
        this.userCartBTB.ItemID = $value.product_id;
        this.authService.postData(this.userCartBTB, "deleteCart").then(
            result => {
                this.recartDataBTB = result;
                if (this.recartDataBTB.cartData) {
                    this.cartDataBTB = this.recartDataBTB.cartData;
                    this.total_item = this.cartDataBTB.length;
                }
            },
            err => {
                this.presentToast("Gagal terhubung ke server.");
            }
        );
    }

    insertBTB() {
        this.authService.postData(this.userCartBTB, "getCart").then(
            result => {
                this.recartDataBTB = result;
                if (this.recartDataBTB.cartData) {
                    this.cartDataBTB = this.recartDataBTB.cartData;
                    this.userCartBTB.cart_id = this.cartDataBTB[0].cart_id;
                    console.log(this.userCartBTB);
                    if (this.userCartBTB.cart_id) {
                        this.authService.postData(this.userCartBTB, "insertBTB").then(
                            result => {
                                this.doAlert();
                                this.app.getRootNav().setRoot(OfficePage);
                            },
                            err => {
                                this.presentToast("Gagal terhubung ke server.");
                            }
                        );
                    } else {
                        this.presentToast("Gagal mengambil produk.");
                    }
                }
            },
            err => {
                this.presentToast("Gagal terhubung ke server.");
            }
        );
    }
    doAlert() {
        let alert = this.alertCtrl.create({
            title: 'Sukses',
            subTitle: 'Konfirmasi penerimaan telah berhasil.',
            buttons: ['Ok']
        });

        alert.present();
    }

    setItems() {
        this.items;
        this.itemsDetail;
    }

    onClear() {
        return this.getRO();
    }
    onCancel() {
        return this.getRO();
    }

    onInput(ev: any) {
        this.setItems();
        let val = ev.target.value;

        if (val && val.trim() !== '') {
            this.items = this.items.filter(function (item) {
                return item.ItemName.toLowerCase().includes(val.toLowerCase());
            });
        }
    }

    openCalendar() {
        const options: CalendarModalOptions = {
            canBackwardsSelected: true,
            title: 'Pilih Tanggal',
            defaultDate: new Date()
        };

        let myCalendar = this.modalCtrl.create(CalendarModal, {
            options: options
        });

        myCalendar.present();

        myCalendar.onDidDismiss((date: CalendarResult, type: string) => {
            if (date === null) {
                this.userCartBTB.tiba = this.userCartBTB.tiba;
            } else {
                this.userCartBTB.tiba = date.string;
            }
        });
    }

    presentToast(msg) {
        let toast = this.toastCtrl.create({
            message: msg,
            duration: 3000
        });
        toast.present();
    }
    
   